<?
/* comment-flak.php

Comment Flak for PHP by Rogers Cadenhead

Version 0.1
Web: http://www.cadenhead.org/workbench/comment-flak
   
Copyright (C) 2006 Rogers Cadenhead

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

// a PHP class library to identify comment spam
class Comment_Flak {

    // DON'T EDIT VARIABLES BELOW THIS LINE
    var $software_version = "0.1";
    var $last_error = "";

    // set up the object
    function Comment_Flak() {
        // no constructor setup necessary
    }

    // report errors
    function report_error($message) {
        error_log("Comment_Flak: " . $message);
    }
    
    // retrieve last error message
    function get_last_error() {
        return $this->last_error;
    }
    
    // generate the comment flak text area components
    function get_comment_flak($last_tab_index, $field_prefix = "comment", $classname = "cf", $flak_count = 13,
        $columns = 70, $rows = 18) {
        
        $output = "";
        if ($classname != "") {
            $output .= "<div class=\"$classname\">";
        }
        for ($i = 0; $i < $flak_count; $i++) {
            $tab_index = $i + $last_tab_index;
            $output .= "<textarea name=\"{$field_prefix}_{$i}\" cols=\"{$columns}\" rows=\"{$rows}\" "
                . "tabindex=\"{$tab_index}\"></textarea>";
        }  
        if ($classname != "") {
            $output .= "</div>";
        }
        return $output;
    }
    
    // check the comment flak component values
    function detect_spam($field_prefix = "comment", $flak_count = 13, $request) { 
        $is_spam = false;
        for ($i = 0; $i < $flak_count; $i++) {
            $field = $field_prefix . "_" . $i;
            if (strlen(trim($request[$field])) > 0) {
                // the field is not empty, so it must be spam
                $is_spam = true;
            }
        }
        return $is_spam;
    } 
}